/*

 Sample how to integrate VB UI for IDA plugin
 http://sandsprite.com/CodeStuff/VB_Plugin_for_Olly.html

*/

#include <windows.h>   
#include <ida.hpp>
#include <idp.hpp>
#include <expr.hpp>
#include <bytes.hpp>
#include <loader.hpp>
#include <kernwin.hpp>

//change path to match your system, register dll with regsvr32 or compile yourself.
#import "C:\\IDA\\plugins\\IdaVbPlugin.dll" raw_interfaces_only

using namespace IdaVbSample;

_CPluginPtr pIPlug(__uuidof(CPlugin));

char comment[] = "This is a sample plugin. It does nothing useful";
char help[] ="Sample Vb UI for IDA Plugin";
char wanted_name[] = "VB Sample plugin 2";
char wanted_hotkey[] = "Alt-0";

void idaapi term(void)  {  pIPlug->Release(); delete pIPlug; CoUninitialize();   }   
void idaapi run(int arg){  pIPlug->DoPluginAction();                             }  
int  idaapi init(void)  {  HRESULT  hr = CoInitialize(NULL); return PLUGIN_KEEP; }

plugin_t PLUGIN =
{
  IDP_INTERFACE_VERSION,
  0,                    // plugin flags
  init,                 // initialize
  term,                 // terminate. this pointer may be NULL.
  run,                  // invoke plugin
  comment,              // long comment about the plugin (status line or hint)
  help,                 // multiline help about the plugin
  wanted_name,          // the preferred short name of the plugin
  wanted_hotkey         // the preferred hotkey to run the plugin
};


//__________________Export API for the VB app to call and access IDA API data
int __stdcall NumFuncs(void){
	return get_func_qty(); 
}

int __stdcall FunctionStart(int n){
	func_t *clsFx = getn_func(n);
	return clsFx->startEA;
}

int __stdcall FunctionEnd(int n){
	func_t *clsFx = getn_func(n);
	return clsFx->endEA;
}

int __stdcall GetBytes(int offset, void *buf, int length){
	return get_many_bytes(offset, buf, length);
}

void __stdcall FuncName(int addr, char *buf, size_t bufsize){
		get_func_name(addr, buf, bufsize);
}

int __stdcall GetAsm(int addr, char* buf, int bufLen){

    flags_t flags;                                                       
    int sLen=0;

    flags = getFlags(addr);                        
    if(isCode(flags)) {                            
        generate_disasm_line(addr, buf, bufLen, GENDSM_MULTI_LINE );
        sLen = tag_remove(buf, buf, bufLen);  
    }

	return sLen;

}

